# coding: utf-8

FONT = 'ＭＳ ゴシック'.encode('CP932')

class Card

	def to_s
		sprintf("%-10s %s", @card['カードNo.'], @card['カード名'])
	end

end

class DeckbuilderModel

	def create_search_items
		# カードNo.検索
		search_number_model = SearchNumberModel.new
		@frm.search_number_view.add_observer search_number_model
		search_number_model.add_observer @cardlist_model

		# カード名検索
		search_name_model = SearchNameModel.new
		@frm.search_name_view.add_observer search_name_model
		search_name_model.add_observer @cardlist_model

		# 種類検索
		search_chara_checkbox_model = SearchCharaCheckboxModel.new
		@frm.search_chara_checkbox_view.add_observer search_chara_checkbox_model
		search_chara_checkbox_model.add_observer @cardlist_model
		@frm.search_chara_checkbox_view.checkbox_set true

		search_event_checkbox_model = SearchEventCheckboxModel.new
		@frm.search_event_checkbox_view.add_observer search_event_checkbox_model
		search_event_checkbox_model.add_observer @cardlist_model
		@frm.search_event_checkbox_view.checkbox_set true

		search_set_checkbox_model = SearchSetCheckboxModel.new
		@frm.search_set_checkbox_view.add_observer search_set_checkbox_model
		search_set_checkbox_model.add_observer @cardlist_model
		@frm.search_set_checkbox_view.checkbox_set true

		search_extra_checkbox_model = SearchExtraCheckboxModel.new
		@frm.search_extra_checkbox_view.add_observer search_extra_checkbox_model
		search_extra_checkbox_model.add_observer @cardlist_model
		@frm.search_extra_checkbox_view.checkbox_set true

		search_partner_type_checkbox_model = SearchPartnerTypeCheckboxModel.new
		@frm.search_partner_type_checkbox_view.add_observer search_partner_type_checkbox_model
		search_partner_type_checkbox_model.add_observer @cardlist_model
		@frm.search_partner_type_checkbox_view.checkbox_set true

		# レアリティ検索
		search_common_checkbox_model = SearchCommonCheckboxModel.new
		@frm.search_common_checkbox_view.add_observer search_common_checkbox_model
		search_common_checkbox_model.add_observer @cardlist_model
		@frm.search_common_checkbox_view.checkbox_set true

		search_uncommon_checkbox_model = SearchUncommonCheckboxModel.new
		@frm.search_uncommon_checkbox_view.add_observer search_uncommon_checkbox_model
		search_uncommon_checkbox_model.add_observer @cardlist_model
		@frm.search_uncommon_checkbox_view.checkbox_set true

		search_rare_checkbox_model = SearchRareCheckboxModel.new
		@frm.search_rare_checkbox_view.add_observer search_rare_checkbox_model
		search_rare_checkbox_model.add_observer @cardlist_model
		@frm.search_rare_checkbox_view.checkbox_set true

		search_double_rare_checkbox_model = SearchDoubleRareCheckboxModel.new
		@frm.search_double_rare_checkbox_view.add_observer search_double_rare_checkbox_model
		search_double_rare_checkbox_model.add_observer @cardlist_model
		@frm.search_double_rare_checkbox_view.checkbox_set true

		search_triple_rare_checkbox_model = SearchTripleRareCheckboxModel.new
		@frm.search_triple_rare_checkbox_view.add_observer search_triple_rare_checkbox_model
		search_triple_rare_checkbox_model.add_observer @cardlist_model
		@frm.search_triple_rare_checkbox_view.checkbox_set false, true

		search_super_rare_checkbox_model = SearchSuperRareCheckboxModel.new
		@frm.search_super_rare_checkbox_view.add_observer search_super_rare_checkbox_model
		search_super_rare_checkbox_model.add_observer @cardlist_model
		@frm.search_super_rare_checkbox_view.checkbox_set false, true

		search_special_checkbox_model = SearchSpecialCheckboxModel.new
		@frm.search_special_checkbox_view.add_observer search_special_checkbox_model
		search_special_checkbox_model.add_observer @cardlist_model
		@frm.search_special_checkbox_view.checkbox_set false, true

		search_trial_checkbox_model = SearchTrialCheckboxModel.new
		@frm.search_trial_checkbox_view.add_observer search_trial_checkbox_model
		search_trial_checkbox_model.add_observer @cardlist_model
		@frm.search_trial_checkbox_view.checkbox_set true

		search_partner_checkbox_model = SearchPartnerCheckboxModel.new
		@frm.search_partner_checkbox_view.add_observer search_partner_checkbox_model
		search_partner_checkbox_model.add_observer @cardlist_model
		@frm.search_partner_checkbox_view.checkbox_set false, true

		search_promotion_checkbox_model = SearchPromotionCheckboxModel.new
		@frm.search_promotion_checkbox_view.add_observer search_promotion_checkbox_model
		search_promotion_checkbox_model.add_observer @cardlist_model
		@frm.search_promotion_checkbox_view.checkbox_set false, true

		# 性別検索
		search_sex_checkbox_model = SearchSexCheckboxModel.new
		@frm.search_man_checkbox_view.add_observer search_sex_checkbox_model
		@frm.search_woman_checkbox_view.add_observer search_sex_checkbox_model
		@frm.search_nonsexual_checkbox_view.add_observer search_sex_checkbox_model
		@frm.search_sex_mode_checkbox_view.add_observer search_sex_checkbox_model
		search_sex_checkbox_model.add_observer @cardlist_model
		@frm.search_man_checkbox_view.checkbox_set true, true
		@frm.search_woman_checkbox_view.checkbox_set true, true
		@frm.search_nonsexual_checkbox_view.checkbox_set true, true
		@frm.search_sex_mode_checkbox_view.checkbox_set true, true

		# 属性検索
		search_attr_mode_checkbox_model = SearchAttributeCheckboxModel.new
		@frm.search_earth_checkbox_view.add_observer search_attr_mode_checkbox_model
		@frm.search_water_checkbox_view.add_observer search_attr_mode_checkbox_model
		@frm.search_fire_checkbox_view.add_observer search_attr_mode_checkbox_model
		@frm.search_air_checkbox_view.add_observer search_attr_mode_checkbox_model
		@frm.search_light_checkbox_view.add_observer search_attr_mode_checkbox_model
		@frm.search_dark_checkbox_view.add_observer search_attr_mode_checkbox_model
		@frm.search_neutral_checkbox_view.add_observer search_attr_mode_checkbox_model
		@frm.search_attr_mode_checkbox_view.add_observer search_attr_mode_checkbox_model
		search_attr_mode_checkbox_model.add_observer @cardlist_model
		@frm.search_earth_checkbox_view.checkbox_set true, true
		@frm.search_water_checkbox_view.checkbox_set true, true
		@frm.search_fire_checkbox_view.checkbox_set true, true
		@frm.search_air_checkbox_view.checkbox_set true, true
		@frm.search_light_checkbox_view.checkbox_set true, true
		@frm.search_dark_checkbox_view.checkbox_set true, true
		@frm.search_neutral_checkbox_view.checkbox_set true, true
		@frm.search_attr_mode_checkbox_view.checkbox_set true, true

		# 攻撃力検索
		search_attack_range_model = SearchAttackRangeModel.new
		@frm.search_attack_range_view.add_observer search_attack_range_model
		search_attack_range_model.add_observer @cardlist_model

		max = @database.inject(0) {|max, card|
			max = if max < card['攻撃力'].to_i then card['攻撃力'].to_i else max end
		}

		min = @database.inject(max) {|min, card|
			min = if min > card['攻撃力'].to_i then card['攻撃力'].to_i else min end
		}

		@frm.search_attack_range_view.set_range min, max

		# 防御力検索
		search_defence_range_model = SearchDefenceRangeModel.new
		@frm.search_defence_range_view.add_observer search_defence_range_model
		search_defence_range_model.add_observer @cardlist_model

		max = @database.inject(0) {|max, card|
			max = if max < card['耐久力'].to_i then card['耐久力'].to_i else max end
		}

		min = @database.inject(max) {|min, card|
			min = if min > card['耐久力'].to_i then card['耐久力'].to_i else min end
		}

		@frm.search_defence_range_view.set_range min, max

		# 攻撃力（補正）検索
		search_attack_diff_range_model = SearchAttackDiffRangeModel.new
		@frm.search_attack_diff_range_view.add_observer search_attack_diff_range_model
		search_attack_diff_range_model.add_observer @cardlist_model

		max = MyInteger.new @database.inject(0) {|max, card|
			max = if max < card['攻撃力（補正）'].to_i then card['攻撃力（補正）'].to_i else max end
		}

		min = MyInteger.new @database.inject(max.to_i) {|min, card|
			min = if min > card['攻撃力（補正）'].to_i then card['攻撃力（補正）'].to_i else min end
		}

		@frm.search_attack_diff_range_view.set_range min, max

		# 耐久力（補正）検索
		search_defence_diff_range_model = SearchDefenceDiffRangeModel.new
		@frm.search_defence_diff_range_view.add_observer search_defence_diff_range_model
		search_defence_diff_range_model.add_observer @cardlist_model

		max = MyInteger.new @database.inject(0) {|max, card|
			max = if max < card['耐久力（補正）'].to_i then card['耐久力（補正）'].to_i else max end
		}

		min = MyInteger.new @database.inject(max.to_i) {|min, card|
			min = if min > card['耐久力（補正）'].to_i then card['耐久力（補正）'].to_i else min end
		}

		@frm.search_defence_diff_range_view.set_range min, max

		# 効果テキスト検索
		search_card_text_model = SearchCardTextModel.new
		@frm.search_card_text_view.add_observer search_card_text_model
		search_card_text_model.add_observer @cardlist_model

		# エクスパンション検索
		search_expantion_model = SearchExpantionModel.new
		@frm.search_expantion_view.add_observer search_expantion_model
		search_expantion_model.add_observer @cardlist_model

		list = @database.inject({}) {|hash, card|
			hash[card['エクスパンション']] = nil unless hash.key? card['エクスパンション']
			hash
		}.keys

		@frm.search_expantion_view.set_list list

		# 参加作品検索
		search_entry_model = SearchEntryModel.new
		@frm.search_entry_view.add_observer search_entry_model
		search_entry_model.add_observer @cardlist_model
	end

end

class DeckbuilderView < VRForm

	@@self_title = 'ChaosTCG デッキ作成支援ツール'.encode('CP932')
	@@self_pos = [0, 0, 980, 680]
	@@decklist_view_pos = [10, 10, 300, 290]
	@@deck_detail_view_pos = [10, 300, 340, 315]
	@@cardlist_view_pos = [400, 10, 300, 290]
	@@card_detail_view_pos = [360, 300, 340, 315]
	@@add_card_view_pos = [320, 45, 70, 25]
	@@add_x_card_view_pos = [320, 95, 70, 25]
	@@del_card_view_pos = [320, 145, 70, 25]
	@@del_x_card_view_pos = [320, 195, 70, 25]
	@@clear_deck_view_pos = [320, 245, 70, 25]

	attr_reader :search_number_view
	attr_reader :search_name_view
	attr_reader :search_chara_checkbox_view
	attr_reader :search_event_checkbox_view
	attr_reader :search_set_checkbox_view
	attr_reader :search_extra_checkbox_view
	attr_reader :search_partner_type_checkbox_view
	attr_reader :search_common_checkbox_view
	attr_reader :search_uncommon_checkbox_view
	attr_reader :search_rare_checkbox_view
	attr_reader :search_double_rare_checkbox_view
	attr_reader :search_triple_rare_checkbox_view
	attr_reader :search_super_rare_checkbox_view
	attr_reader :search_special_checkbox_view
	attr_reader :search_trial_checkbox_view
	attr_reader :search_partner_checkbox_view
	attr_reader :search_promotion_checkbox_view
	attr_reader :search_man_checkbox_view
	attr_reader :search_woman_checkbox_view
	attr_reader :search_nonsexual_checkbox_view
	attr_reader :search_sex_mode_checkbox_view
	attr_reader :search_earth_checkbox_view
	attr_reader :search_water_checkbox_view
	attr_reader :search_fire_checkbox_view
	attr_reader :search_air_checkbox_view
	attr_reader :search_light_checkbox_view
	attr_reader :search_dark_checkbox_view
	attr_reader :search_neutral_checkbox_view
	attr_reader :search_attr_mode_checkbox_view
	attr_reader :search_attack_range_view
	attr_reader :search_defence_range_view
	attr_reader :search_attack_diff_range_view
	attr_reader :search_defence_diff_range_view
	attr_reader :search_card_text_view
	attr_reader :search_expantion_view
	attr_reader :search_entry_view

	def create_search_items
		# カードNo.検索
		addControl SearchNumberView, 'search_number_view', '', 700, 30, 260, 20

		# カード名検索
		addControl SearchNameView, 'search_name_view', '', 700, 55, 260, 20

		# 種類検索
		addControl VRStatic, 'type_text', '種類'.encode('CP932'), 730, 80, 100, 20
		@type_text.setFont @screen.factory.newfont(FONT, 12, 0, 8)

		addControl SearchCharaCheckboxView, 'search_chara_checkbox_view', '', 700, 100, 100, 20
		addControl SearchEventCheckboxView, 'search_event_checkbox_view', '', 700, 120, 100, 20
		addControl SearchSetCheckboxView, 'search_set_checkbox_view', '', 700, 140, 100, 20
		addControl SearchExtraCheckboxView, 'search_extra_checkbox_view', '', 700, 160, 100, 20
		addControl SearchPartnerTypeCheckboxView, 'search_partner_type_checkbox_view', '', 700, 180, 100, 20

		# レアリティ検索
		addControl VRStatic, 'rarity_text', 'レアリティ'.encode('CP932'), 730, 205, 100, 20
		@rarity_text.setFont @screen.factory.newfont(FONT, 12, 0, 8)

		addControl SearchCommonCheckboxView, 'search_common_checkbox_view', '', 700, 225, 100, 20
		addControl SearchUncommonCheckboxView, 'search_uncommon_checkbox_view', '', 700, 245, 100, 20
		addControl SearchRareCheckboxView, 'search_rare_checkbox_view', '', 700, 265, 100, 20
		addControl SearchDoubleRareCheckboxView, 'search_double_rare_checkbox_view', '', 700, 285, 100, 20
		addControl SearchTripleRareCheckboxView, 'search_triple_rare_checkbox_view', '', 700, 305, 100, 20
		addControl SearchSuperRareCheckboxView, 'search_super_rare_checkbox_view', '', 700, 325, 100, 20
		addControl SearchSpecialCheckboxView, 'search_special_checkbox_view', '', 700, 345, 100, 20
		addControl SearchTrialCheckboxView, 'search_trial_checkbox_view', '', 700, 365, 100, 20
		addControl SearchPartnerCheckboxView, 'search_partner_checkbox_view', '', 700, 385, 100, 20
		addControl SearchPromotionCheckboxView, 'search_promotion_checkbox_view', '', 700, 405, 100, 20

		# 性別検索
		addControl VRStatic, 'sex_text', '性別'.encode('CP932'), 850, 80, 100, 20
		@sex_text.setFont @screen.factory.newfont(FONT, 12, 0, 8)

		addControl SearchManCheckboxView, 'search_man_checkbox_view', '', 820, 100, 100, 20
		addControl SearchWomanCheckboxView, 'search_woman_checkbox_view', '', 820, 120, 100, 20
		addControl SearchNonsexualCheckboxView, 'search_nonsexual_checkbox_view', '', 820, 140, 100, 20
		addControl SearchSexModeCheckboxView, 'search_sex_mode_checkbox_view', '', 820, 180, 150, 20

		# 属性検索
		addControl VRStatic, 'attribute_text', '属性'.encode('CP932'), 850, 205, 100, 20
		@attribute_text.setFont @screen.factory.newfont(FONT, 12, 0, 8)

		addControl SearchEarthCheckboxView, 'search_earth_checkbox_view', '', 820, 225, 100, 20
		addControl SearchWaterCheckboxView, 'search_water_checkbox_view', '', 820, 245, 100, 20
		addControl SearchFireCheckboxView, 'search_fire_checkbox_view', '', 820, 265, 100, 20
		addControl SearchAirCheckboxView, 'search_air_checkbox_view', '', 820, 285, 100, 20
		addControl SearchLightCheckboxView, 'search_light_checkbox_view', '', 820, 305, 100, 20
		addControl SearchDarkCheckboxView, 'search_dark_checkbox_view', '', 820, 325, 100, 20
		addControl SearchNeutralCheckboxView, 'search_neutral_checkbox_view', '', 820, 345, 100, 20
		addControl SearchAttrModeCheckboxView, 'search_attr_mode_checkbox_view', '', 820, 385, 150, 20

		# 攻撃力検索
		addControl SearchAttackRangeView, 'search_attack_range_view', '', 700, 430, 260, 20

		# 耐久力検索
		addControl SearchDefenceRangeView, 'search_defence_range_view', '', 700, 455, 260, 20

		# 攻撃力（補正）検索
		addControl SearchAttackDiffRangeView, 'search_attack_diff_range_view', '', 700, 480, 260, 20

		# 耐久力（補正）検索
		addControl SearchDefenceDiffRangeView, 'search_defence_diff_range_view', '', 700, 505, 260, 20

		# 効果テキスト検索
		addControl SearchCardTextView, 'search_card_text_view', '', 700, 535, 260, 20

		# エクスパンション検索
		addControl SearchExpantionView, 'search_expantion_view', '', 700, 560, 260, 20

		# 参加作品検索
		addControl SearchEntryView, 'search_entry_view', '', 700, 585, 260, 20
	end

end

class CardlistView < VRPanel

	@@text_pos = [75, 0, 225, 20]
	@@text_font = [FONT, 14, 0, 9]
	@@listbox_pos = [0, 20, 300, 275]
	@@listbox_font = [FONT, 12]
	@@times = 4

end

class DecklistView < VRPanel

	@@text_pos = [90, 0, 210, 20]
	@@text_font = [FONT, 14, 0, 9]
	@@listbox_pos = [0, 20, 300, 275]
	@@listbox_font = [FONT, 12]
	@@times = 4

end

class CardDetailView < VRPanel

	@@text_pos = [135, 0, 205, 20]
	@@text_font = [FONT, 14, 0, 9]
	@@textbox_pos = [0, 20, 340, 293]

	def paint(textbox, card)

		textbox.text = ''

		attr = textbox.selformat
		attr.fontface = 'ＭＳ Ｐゴシック'.encode('CP932').force_encoding('ASCII-8BIT')
		attr.height = -12
		attr.point = 90
		attr.weight = 400
		attr.pitch_family = 49
		attr.charset = 128

		attr.bold = true
		textbox.addtextwithattr "カードNo.\t： ".encode('CP932'), attr
		attr.bold = false
		textbox.addtextwithattr " #{card['カードNo.']}\n".encode('CP932'), attr

		attr.bold = true
		textbox.addtextwithattr "カード名\t\t： ".encode('CP932'), attr
		attr.bold = false
		textbox.addtextwithattr " #{card['カード名']}\n".encode('CP932'), attr

		attr.bold = true
		textbox.addtextwithattr "カード名(カナ)\t： ".encode('CP932'), attr
		attr.bold = false
		textbox.addtextwithattr " #{card['カナ']}\n".encode('CP932'), attr

		attr.bold = true
		textbox.addtextwithattr "種類／レアリティ\t： ".encode('CP932'), attr
		attr.bold = false
		textbox.addtextwithattr " #{card['種類']}／#{card['レアリティ']}\n".encode('CP932'), attr

		attr.bold = true
		textbox.addtextwithattr "性別／属性\t： ".encode('CP932'), attr
		attr.bold = false
		textbox.addtextwithattr " #{card['性別']}／#{card['属性']}\n".encode('CP932'), attr

		attr.bold = true
		textbox.addtextwithattr "攻撃力／補正\t： ".encode('CP932'), attr
		attr.bold = false
		textbox.addtextwithattr " #{card['攻撃力']}／#{card['攻撃力（補正）']}\n".encode('CP932'), attr

		attr.bold = true
		textbox.addtextwithattr "耐久力／補正\t： ".encode('CP932'), attr
		attr.bold = false
		textbox.addtextwithattr " #{card['耐久力']}／#{card['耐久力（補正）']}\n".encode('CP932'), attr

		attr.bold = true
		textbox.addtextwithattr "エクスパンション\t： ".encode('CP932'), attr
		attr.bold = false
		textbox.addtextwithattr " #{card['エクスパンション']}\n".encode('CP932'), attr

		attr.bold = true
		textbox.addtextwithattr "参加作品\t： ".encode('CP932'), attr
		attr.bold = false
		textbox.addtextwithattr " #{card['参加作品']}\n".encode('CP932'), attr

		attr.bold = true
		textbox.addtextwithattr "\n《効果テキスト》\n".encode('CP932'), attr
		attr.bold = false

		text = "#{card['効果テキスト']}\n".gsub("<br>","\n").encode('CP932')

		until text.empty?
			pre, post = /([^<]*)<font (.*)/im.match(text).to_a.values_at(1, 2)
			if pre
				textbox.addtextwithattr pre + " ", attr
			end
			if post
				color, str, text = /color="?(blue|red)"?>([^<]*)<\/font>(.*)/im.match(post).to_a.values_at(1, 2, 3)
				if color =~ /blue/
					attr.color = 0xff0000
				else
					attr.color = 0x0000ff
				end
				textbox.addtextwithattr str + " ", attr
				attr.color = 0
			else
				textbox.addtextwithattr text, attr
				text = ''
			end
		end

		attr.bold = true
		textbox.addtextwithattr "\n\n《フレーバー》\n".encode('CP932'), attr
		attr.bold = false
		textbox.addtextwithattr "#{card['フレーバー']}\n".encode('CP932'), attr

	end

end

class DeckDetailModel

	def deck2detail(deck)
		detail = {
			'レアリティ' => {'C' => 0, 'U' => 0, 'R' => 0, 'RR' => 0, 'RRR' => 0,
										   'SR' => 0, 'SP' => 0, 'T' => 0, 'P' => 0, 'PR' => 0},
			'種類' => {'Chara' => 0, 'Event' => 0, 'Set' => 0, 'Extra' => 0, 'Partner' => 0},
#			'属性' => {'地' => 0, '水' => 0, '火' => 0, '風' => 0, '光' => 0, '闇' => 0, '無' => 0},
#			'性別' => {'女' => 0, '男' => 0},
			'登場' => {'総数' => 0, '表->裏' => 0, '他->控' => 0, '表->控' => 0},
			'枚数' => 0
		}
		deck.each {|item|
			unless /^~/ =~ item[0]
				index = @database.index{|card| Regexp.new(card.to_s).match(item[0])}
				card = @database[index]
				item[1].times{
					detail['枚数'] += 1
					detail['レアリティ'][card['レアリティ']] += 1
					detail['種類'][card['種類']] += 1
					detail['登場']['総数'] += 1 if card['効果テキスト'] =~ /【登場】/
					detail['登場']['表->裏'] += 1 if card['効果テキスト'] =~ /【登場】〔自分のキャラを1体【表】から【裏】にする/
					detail['登場']['表->控'] += 1 if card['効果テキスト'] =~ /【登場】〔自分の【表】のキャラを1体控え室に置く/
					detail['登場']['他->控'] += 1 if card['効果テキスト'] =~ /【登場】(?!〔自分の【表】).+控え室に置く/
=begin
					detail['属性']['地'] += 1 if card['属性'] =~ /地/
					detail['属性']['水'] += 1 if card['属性'] =~ /水/
					detail['属性']['火'] += 1 if card['属性'] =~ /火/
					detail['属性']['風'] += 1 if card['属性'] =~ /風/
					detail['属性']['光'] += 1 if card['属性'] =~ /光/
					detail['属性']['闇'] += 1 if card['属性'] =~ /闇/
					detail['属性']['無'] += 1 if card['属性'] =~ /無/
					detail['性別']['女'] += 1 if card['性別'] =~ /女/
					detail['性別']['男'] += 1 if card['性別'] =~ /男/
=end
				}
			end
		}
		detail
	end

end

class DeckDetailView < VRPanel

	@@text_pos = [135, 0, 205, 20]
	@@text_font = [FONT, 14, 0, 9]
	@@textbox1_pos = [0, 20, 170, 293]
	@@textbox2_pos = [170, 20, 170, 293]

	def paint(textbox1, textbox2, detail)
		textbox1.text = ''
		textbox2.text = ''

		detail['枚数'] = 1 if detail['枚数'] == 0

		attr = textbox1.selformat
		attr.fontface = 'ＭＳ Ｐゴシック'.encode('CP932').force_encoding('ASCII-8BIT')
		attr.height = -12
		attr.point = 90
		attr.weight = 400
		attr.pitch_family = 49
		attr.charset = 128

		text = <<-EOS
レアリティ
		EOS

		attr.bold = true
		textbox1.addtextwithattr text.encode('CP932'), attr

		text = <<-EOS
C\t: #{sprintf "%2d", detail['レアリティ']['C']}枚（#{sprintf "%5.2f", detail['レアリティ']['C'] * 100.0 / detail['枚数']}%）
U\t: #{sprintf "%2d", detail['レアリティ']['U']}枚（#{sprintf "%5.2f", detail['レアリティ']['U'] * 100.0 / detail['枚数']}%）
R\t: #{sprintf "%2d", detail['レアリティ']['R']}枚（#{sprintf "%5.2f", detail['レアリティ']['R'] * 100.0 / detail['枚数']}%）
RR\t: #{sprintf "%2d", detail['レアリティ']['RR']}枚（#{sprintf "%5.2f", detail['レアリティ']['RR'] * 100.0 / detail['枚数']}%）
RRR\t: #{sprintf "%2d", detail['レアリティ']['RRR']}枚（#{sprintf "%5.2f", detail['レアリティ']['RRR'] * 100.0 / detail['枚数']}%）
SR\t: #{sprintf "%2d", detail['レアリティ']['SR']}枚（#{sprintf "%5.2f", detail['レアリティ']['SR'] * 100.0 / detail['枚数']}%）
SP\t: #{sprintf "%2d", detail['レアリティ']['SP']}枚（#{sprintf "%5.2f", detail['レアリティ']['SP'] * 100.0 / detail['枚数']}%）
T\t: #{sprintf "%2d", detail['レアリティ']['T']}枚（#{sprintf "%5.2f", detail['レアリティ']['T'] * 100.0 / detail['枚数']}%）
P\t: #{sprintf "%2d", detail['レアリティ']['P']}枚（#{sprintf "%5.2f", detail['レアリティ']['P'] * 100.0 / detail['枚数']}%）
PR\t: #{sprintf "%2d", detail['レアリティ']['PR']}枚（#{sprintf "%5.2f", detail['レアリティ']['PR'] * 100.0 / detail['枚数']}%）

		EOS


		attr.bold = false
		textbox1.addtextwithattr text.encode('CP932'), attr


		attr = textbox2.selformat
		attr.fontface = 'ＭＳ Ｐゴシック'.encode('CP932').force_encoding('ASCII-8BIT')
		attr.height = -12
		attr.point = 90
		attr.weight = 400
		attr.pitch_family = 49
		attr.charset = 128

		text = <<-EOS
種類別
		EOS

		attr.bold = true
		textbox2.addtextwithattr text.encode('CP932'), attr

		text = <<-EOS
Chara\t: #{sprintf "%2d", detail['種類']['Chara']}枚（#{sprintf "%5.2f", detail['種類']['Chara'] * 100.0 / detail['枚数']}%）
Event\t: #{sprintf "%2d", detail['種類']['Event']}枚（#{sprintf "%5.2f", detail['種類']['Event'] * 100.0 / detail['枚数']}%）
Set\t: #{sprintf "%2d", detail['種類']['Set']}枚（#{sprintf "%5.2f", detail['種類']['Set'] * 100.0 / detail['枚数']}%）
Extra\t: #{sprintf "%2d", detail['種類']['Extra']}枚（#{sprintf "%5.2f", detail['種類']['Extra'] * 100.0 / detail['枚数']}%）
Partner\t: #{sprintf "%2d", detail['種類']['Partner']}枚（#{sprintf "%5.2f", detail['種類']['Partner'] * 100.0 / detail['枚数']}%）

		EOS

		attr.bold = false
		textbox2.addtextwithattr text.encode('CP932'), attr

		num = if detail['種類']['Chara'] > 0 then detail['種類']['Chara'] else 1 end

		text = <<-EOS
登場／キャラ比率
		EOS

		attr.bold = true
		textbox2.addtextwithattr text.encode('CP932'), attr

		text = <<-EOS
総数\t: #{sprintf "%2d", detail['登場']['総数'] }枚（#{sprintf "%5.2f", detail['登場']['総数']  * 100.0 / num}%）
表->裏\t: #{sprintf "%2d", detail['登場']['表->裏']}枚（#{sprintf "%5.2f", detail['登場']['表->裏'] * 100.0 / num}%）
表->控\t: #{sprintf "%2d", detail['登場']['表->控']}枚（#{sprintf "%5.2f", detail['登場']['表->控'] * 100.0 / num}%）
他->控\t: #{sprintf "%2d", detail['登場']['他->控']}枚（#{sprintf "%5.2f", detail['登場']['他->控'] * 100.0 / num}%）

		EOS

		attr.bold = false
		textbox2.addtextwithattr text.encode('CP932'), attr
	end

end

class AddCardModel

	@@sb_pre_mark = '~'
	@@sb_post_mark = ''

end

class AddCardView < VRButton

	@@add_card_view_text = '＜追加'.encode('CP932')
	@@add_card_view_font = [FONT, 12, 0, 6]

end

class AddXCardView < VRButton

	@@add_x_card_view_text = '<<4枚追加'.encode('CP932')
	@@add_x_card_view_font = [FONT, 12, 0, 6]
	@@add_x_card_view_times = 4

end

class DelCardView < VRButton

	@@del_card_view_text = '削除＞'.encode('CP932')
	@@del_card_view_font = [FONT, 12, 0, 6]

end

class DelXCardView < VRButton

	@@del_x_card_view_text = '4枚削除>>'.encode('CP932')
	@@del_x_card_view_font = [FONT, 12, 0, 6]
	@@del_x_card_view_times = 4

end

class ClearDeckView < VRButton

	@@clear_deck_view_text = 'クリア'.encode('CP932')
	@@clear_deck_view_font = [FONT, 12, 0, 6]

end

class SearchNumberModel < SearchTextModel

	def get_index
		:number
	end

	def get_block(text)
		if text.length > 0
			lambda{|result, card|
				begin
					if Regexp.new(text) =~ card['カードNo.']
						result << card
					end
				rescue
					# 正規表現エラーは無視
				end
				result
			}
		else
			nil
		end
	end

end

class SearchNumberView < SearchTextView

	@@text_label = 'カードNo.'.encode('CP932')
	@@text_pos = [20, 3, 60, 20]
	@@text_font = [FONT, 12, 0, 8]
	@@edit_pos = [90, 0, 170, 20]
	@@edit_font = [FONT, 12]

	def construct
		super @@text_label, @@text_pos, @@text_font, @@edit_pos, @@edit_font
	end

end

class SearchNameModel < SearchTextModel

	def get_index
		:name
	end

	def get_block(text)
		if text.length > 0
			lambda{|result, card|
				begin
					if Regexp.new(text) =~ card['カード名']
						result << card
					end
				rescue
					# 正規表現エラーは無視
				end
				result
			}
		else
			nil
		end
	end

end

class SearchNameView < SearchTextView

	@@text_label = 'カード名'.encode('CP932')
	@@text_pos = [20, 3, 60, 20]
	@@text_font = [FONT, 12, 0, 8]
	@@edit_pos = [90, 0, 170, 20]
	@@edit_font = [FONT, 12]

	def construct
		super @@text_label, @@text_pos, @@text_font, @@edit_pos, @@edit_font
	end

end

class SearchCharaCheckboxModel < SearchCheckboxModel

	def get_index
		:type_chara
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'Chara' == card['種類']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchCharaCheckboxView < SearchCheckboxView

	@@text_label = 'Chara'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchEventCheckboxModel < SearchCheckboxModel

	def get_index
		:type_event
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'Event' == card['種類']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchEventCheckboxView < SearchCheckboxView

	@@text_label = 'Event'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchSetCheckboxModel < SearchCheckboxModel

	def get_index
		:type_set
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'Set' == card['種類']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchSetCheckboxView < SearchCheckboxView

	@@text_label = 'Set'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchExtraCheckboxModel < SearchCheckboxModel

	def get_index
		:type_extra
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'Extra' == card['種類']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchExtraCheckboxView < SearchCheckboxView

	@@text_label = 'Extra'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchPartnerTypeCheckboxModel < SearchCheckboxModel

	def get_index
		:type_partner
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'Partner' == card['種類']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchPartnerTypeCheckboxView < SearchCheckboxView

	@@text_label = 'Partner'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchCommonCheckboxModel < SearchCheckboxModel

	def get_index
		:rarity_common
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'C' == card['レアリティ']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchCommonCheckboxView < SearchCheckboxView

	@@text_label = 'C'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchUncommonCheckboxModel < SearchCheckboxModel

	def get_index
		:rarity_uncommon
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'U' == card['レアリティ']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchUncommonCheckboxView < SearchCheckboxView

	@@text_label = 'U'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchRareCheckboxModel < SearchCheckboxModel

	def get_index
		:rarity_rare
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'R' == card['レアリティ']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchRareCheckboxView < SearchCheckboxView

	@@text_label = 'R'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchDoubleRareCheckboxModel < SearchCheckboxModel

	def get_index
		:rarity_double_rare
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'RR' == card['レアリティ']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchDoubleRareCheckboxView < SearchCheckboxView

	@@text_label = 'RR'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchTripleRareCheckboxModel < SearchCheckboxModel

	def get_index
		:rarity_triple_rare
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'RRR' == card['レアリティ']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchTripleRareCheckboxView < SearchCheckboxView

	@@text_label = 'RRR'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchSuperRareCheckboxModel < SearchCheckboxModel

	def get_index
		:rarity_super_rare
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'SR' == card['レアリティ']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchSuperRareCheckboxView < SearchCheckboxView

	@@text_label = 'SR'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchSpecialCheckboxModel < SearchCheckboxModel

	def get_index
		:rarity_special
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'SP' == card['レアリティ']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchSpecialCheckboxView < SearchCheckboxView

	@@text_label = 'SP'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchTrialCheckboxModel < SearchCheckboxModel

	def get_index
		:rarity_trial
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'T' == card['レアリティ']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchTrialCheckboxView < SearchCheckboxView

	@@text_label = 'T'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchPartnerCheckboxModel < SearchCheckboxModel

	def get_index
		:rarity_partner
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'P' == card['レアリティ']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchPartnerCheckboxView < SearchCheckboxView

	@@text_label = 'P'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchPromotionCheckboxModel < SearchCheckboxModel

	def get_index
		:rarity_promotion
	end

	def get_block(obj, flag)
		unless flag
			lambda{|result, card|
				unless 'PR' == card['レアリティ']
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchPromotionCheckboxView < SearchCheckboxView

	@@text_label = 'PR'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchSexCheckboxModel < SearchCheckboxModel

	def get_index
		:sex_checkbox
	end

	def get_block(obj, flag)
		@flag[obj.class] = flag

		block = lambda{|cond_array, result, card|
			if cond_array.map{|cond| cond[card]}.all?
				result << card
			end
			result
		}.curry

		cond_array = []
		count = @flag.count{|item| item[1] and item[0] != SearchSexModeCheckboxView}

		if count == 0
			cond_array << lambda{|card| false}
		else
			if @flag[SearchSexModeCheckboxView]
				if count == 1
					cond_array << lambda{|card| /男/ =~ card['性別']} if @flag[SearchManCheckboxView]
					cond_array << lambda{|card| /女/ =~ card['性別']} if @flag[SearchWomanCheckboxView]
					cond_array << lambda{|card| /-/ =~ card['性別']} if @flag[SearchNonsexualCheckboxView]
				else
					cond_array << lambda{|card| '男' != card['性別']} unless @flag[SearchManCheckboxView]
					cond_array << lambda{|card| '女' != card['性別']} unless @flag[SearchWomanCheckboxView]
					cond_array << lambda{|card| '-' != card['性別']} unless @flag[SearchNonsexualCheckboxView]
				end
			else
				if count == 1
					cond_array << lambda{|card| '男' == card['性別']} if @flag[SearchManCheckboxView]
					cond_array << lambda{|card| '女' == card['性別']} if @flag[SearchWomanCheckboxView]
					cond_array << lambda{|card| '-' == card['性別']} if @flag[SearchNonsexualCheckboxView]
				else
					cond_array << lambda{|card| /男/ =~ card['性別']} if @flag[SearchManCheckboxView]
					cond_array << lambda{|card| /女/ =~ card['性別']} if @flag[SearchWomanCheckboxView]
					cond_array << lambda{|card| /-/ =~ card['性別']} if @flag[SearchNonsexualCheckboxView]
				end
			end
		end

		cond_array << lambda{|card| true} if cond_array.empty?

		block[cond_array]
	end

end

class SearchManCheckboxView < SearchCheckboxView

	@@text_label = '男'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchWomanCheckboxView < SearchCheckboxView

	@@text_label = '女'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchNonsexualCheckboxView < SearchCheckboxView

	@@text_label = 'その他'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchSexModeCheckboxView < SearchCheckboxView

	@@text_label = '～を含む(OR)'.encode('CP932')
	@@text_pos = [20, 0, 150, 20]
	@@text_font = [FONT, 12, 0, 0]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchAttributeCheckboxModel < SearchCheckboxModel

	def get_index
		:attribute_checkbox
	end

	def get_block(obj, flag)
		@flag[obj.class] = flag

		block = lambda{|cond_array, result, card|
			if cond_array.map{|cond| cond[card]}.all?
				result << card
			end
			result
		}.curry

		cond_array = []
		count = @flag.count{|item| item[1] and item[0] != SearchAttrModeCheckboxView}

		if count == 0
			cond_array << lambda{|card| false}
		else
			if @flag[SearchAttrModeCheckboxView]
				if count == 1
					cond_array << lambda{|card| /地/ =~ card['属性']} if @flag[SearchEarthCheckboxView]
					cond_array << lambda{|card| /水/ =~ card['属性']} if @flag[SearchWaterCheckboxView]
					cond_array << lambda{|card| /火/ =~ card['属性']} if @flag[SearchFireCheckboxView]
					cond_array << lambda{|card| /風/ =~ card['属性']} if @flag[SearchAirCheckboxView]
					cond_array << lambda{|card| /光/ =~ card['属性']} if @flag[SearchLightCheckboxView]
					cond_array << lambda{|card| /闇/ =~ card['属性']} if @flag[SearchDarkCheckboxView]
					cond_array << lambda{|card| /無/ =~ card['属性']} if @flag[SearchNeutralCheckboxView]
				else
					cond_array << lambda{|card| '地' != card['属性']} unless @flag[SearchEarthCheckboxView]
					cond_array << lambda{|card| '水' != card['属性']} unless @flag[SearchWaterCheckboxView]
					cond_array << lambda{|card| '火' != card['属性']} unless @flag[SearchFireCheckboxView]
					cond_array << lambda{|card| '風' != card['属性']} unless @flag[SearchAirCheckboxView]
					cond_array << lambda{|card| '光' != card['属性']} unless @flag[SearchLightCheckboxView]
					cond_array << lambda{|card| '闇' != card['属性']} unless @flag[SearchDarkCheckboxView]
					cond_array << lambda{|card| '無' != card['属性']} unless @flag[SearchNeutralCheckboxView]
				end
			else
				if count == 1
					cond_array << lambda{|card| '地' == card['属性']} if @flag[SearchEarthCheckboxView]
					cond_array << lambda{|card| '水' == card['属性']} if @flag[SearchWaterCheckboxView]
					cond_array << lambda{|card| '火' == card['属性']} if @flag[SearchFireCheckboxView]
					cond_array << lambda{|card| '風' == card['属性']} if @flag[SearchAirCheckboxView]
					cond_array << lambda{|card| '光' == card['属性']} if @flag[SearchLightCheckboxView]
					cond_array << lambda{|card| '闇' == card['属性']} if @flag[SearchDarkCheckboxView]
					cond_array << lambda{|card| '無' == card['属性']} if @flag[SearchNeutralCheckboxView]
				else
					cond_array << lambda{|card| /地/ =~ card['属性']} if @flag[SearchEarthCheckboxView]
					cond_array << lambda{|card| /水/ =~ card['属性']} if @flag[SearchWaterCheckboxView]
					cond_array << lambda{|card| /火/ =~ card['属性']} if @flag[SearchFireCheckboxView]
					cond_array << lambda{|card| /風/ =~ card['属性']} if @flag[SearchAirCheckboxView]
					cond_array << lambda{|card| /光/ =~ card['属性']} if @flag[SearchLightCheckboxView]
					cond_array << lambda{|card| /闇/ =~ card['属性']} if @flag[SearchDarkCheckboxView]
					cond_array << lambda{|card| /無/ =~ card['属性']} if @flag[SearchNeutralCheckboxView]
				end
			end
		end

		cond_array << lambda{|card| true} if cond_array.empty?

		block[cond_array]
	end

end

class SearchEarthCheckboxView < SearchCheckboxView

	@@text_label = '地'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchWaterCheckboxView < SearchCheckboxView

	@@text_label = '水'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchFireCheckboxView < SearchCheckboxView

	@@text_label = '火'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchAirCheckboxView < SearchCheckboxView

	@@text_label = '風'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchLightCheckboxView < SearchCheckboxView

	@@text_label = '光'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchDarkCheckboxView < SearchCheckboxView

	@@text_label = '闇'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchNeutralCheckboxView < SearchCheckboxView

	@@text_label = '無'.encode('CP932')
	@@text_pos = [20, 0, 100, 20]
	@@text_font = [FONT, 12, 0, 8]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchAttrModeCheckboxView < SearchCheckboxView

	@@text_label = '～を含む(OR)'.encode('CP932')
	@@text_pos = [20, 0, 150, 20]
	@@text_font = [FONT, 12, 0, 0]

	def construct
		super @@text_label, @@text_pos, @@text_font
	end

end

class SearchAttackRangeModel < SearchRangeModel

	def get_index
		:range_attack
	end

	def get_block(first, last)
		if first and last
			lambda{|result, card|
				if first <= card['攻撃力'].to_i and card['攻撃力'].to_i <= last
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchAttackRangeView < SearchRangeView

	@@text1_label = '攻撃力'.encode('CP932')
	@@text1_pos = [20, 3, 120, 20]
	@@text1_font = [FONT, 12, 0, 8]
	@@first_pos = [120, 0, 55, 300]
	@@first_font = [FONT, 12]
	@@text2_pos = [183, 5, 17, 20]
	@@text2_font = [FONT, 12, 0, 1]
	@@last_pos = [205, 0, 55, 300]
	@@last_font = [FONT, 12]

	def construct
		super(
			@@text1_label,
			@@text1_pos,
			@@text1_font,
			@@first_pos,
			@@first_font,
			@@text2_pos,
			@@text2_font,
			@@last_pos,
			@@last_font)
	end

end

class SearchDefenceRangeModel < SearchRangeModel

	def get_index
		:range_defence
	end

	def get_block(first, last)
		if first and last
			lambda{|result, card|
				if first <= card['耐久力'].to_i and card['耐久力'].to_i <= last
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchDefenceRangeView < SearchRangeView

	@@text1_label = '耐久力'.encode('CP932')
	@@text1_pos = [20, 3, 120, 20]
	@@text1_font = [FONT, 12, 0, 8]
	@@first_pos = [120, 0, 55, 300]
	@@first_font = [FONT, 12]
	@@text2_pos = [183, 5, 17, 20]
	@@text2_font = [FONT, 12, 0, 1]
	@@last_pos = [205, 0, 55, 300]
	@@last_font = [FONT, 12]

	def construct
		super(
			@@text1_label,
			@@text1_pos,
			@@text1_font,
			@@first_pos,
			@@first_font,
			@@text2_pos,
			@@text2_font,
			@@last_pos,
			@@last_font)
	end

end

class MyInteger

	def initialize(num)
		@num = num
	end

	def +(other)
		MyInteger.new @num + other.to_i
	end

	def *(other)
		MyInteger.new @num * other.to_i
	end

	def /(other)
		MyInteger.new @num / other.to_i
	end

	def succ
		MyInteger.new @num + 1
	end

	def <=>(other)
		@num <=> other.to_i
	end

	def to_i
		@num
	end

	def to_s
		if @num > 0
			'+' + @num.to_s
		else
			@num.to_s
		end
	end

end

class SearchAttackDiffRangeModel < SearchRangeModel

	def get_index
		:range_attack_diff
	end

	def get_block(first, last)
		if first and last
			lambda{|result, card|
				if first <= card['攻撃力（補正）'].to_i and card['攻撃力（補正）'].to_i <= last
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchAttackDiffRangeView < SearchRangeView

	@@text1_label = '攻撃力（補正）'.encode('CP932')
	@@text1_pos = [20, 3, 120, 20]
	@@text1_font = [FONT, 12, 0, 8]
	@@first_pos = [120, 0, 55, 300]
	@@first_font = [FONT, 12]
	@@text2_pos = [183, 5, 17, 20]
	@@text2_font = [FONT, 12, 0, 1]
	@@last_pos = [205, 0, 55, 300]
	@@last_font = [FONT, 12]

	def construct
		super(
			@@text1_label,
			@@text1_pos,
			@@text1_font,
			@@first_pos,
			@@first_font,
			@@text2_pos,
			@@text2_font,
			@@last_pos,
			@@last_font)
	end

end

class SearchDefenceDiffRangeModel < SearchRangeModel

	def get_index
		:range_defence_diff
	end

	def get_block(first, last)
		if first and last
			lambda{|result, card|
				if first <= card['耐久力（補正）'].to_i and card['耐久力（補正）'].to_i <= last
					result << card
				end
				result
			}
		else
			nil
		end
	end

end

class SearchDefenceDiffRangeView < SearchRangeView

	@@text1_label = '耐久力（補正）'.encode('CP932')
	@@text1_pos = [20, 3, 120, 20]
	@@text1_font = [FONT, 12, 0, 8]
	@@first_pos = [120, 0, 55, 300]
	@@first_font = [FONT, 12]
	@@text2_pos = [183, 5, 17, 20]
	@@text2_font = [FONT, 12, 0, 1]
	@@last_pos = [205, 0, 55, 300]
	@@last_font = [FONT, 12]

	def construct
		super(
			@@text1_label,
			@@text1_pos,
			@@text1_font,
			@@first_pos,
			@@first_font,
			@@text2_pos,
			@@text2_font,
			@@last_pos,
			@@last_font)
	end

end

class SearchCardTextModel < SearchTextModel

	def get_index
		:card_text
	end

	def get_block(text)
		if text.length > 0
			lambda{|result, card|
				begin
					if Regexp.new(text) =~ card['効果テキスト']
						result << card
					end
				rescue
					# 正規表現エラーは無視
				end
				result
			}
		else
			nil
		end
	end

end

class SearchCardTextView < SearchTextView

	@@text_label = '効果テキスト'.encode('CP932')
	@@text_pos = [20, 3, 80, 20]
	@@text_font = [FONT, 12, 0, 8]
	@@edit_pos = [110, 0, 150, 20]
	@@edit_font = [FONT, 12]

	def construct
		super @@text_label, @@text_pos, @@text_font, @@edit_pos, @@edit_font
	end

end

class SearchExpantionModel < SearchComboModel

	def get_index
		:expantion
	end

	def get_block(text)
		if text.length > 0
			lambda{|result, card|
				begin
					if Regexp.new(text) =~ card['エクスパンション']
						result << card
					end
				rescue
					# 正規表現エラーは無視
				end
				result
			}
		else
			nil
		end
	end

end

class SearchExpantionView < SearchComboView

	@@text_label = 'エクスパンション'.encode('CP932')
	@@text_pos = [20, 3, 110, 20]
	@@text_font = [FONT, 12, 0, 8]
	@@edit_pos = [135, 0, 125, 200]
	@@edit_font = [FONT, 10]

	def construct
		super @@text_label, @@text_pos, @@text_font, @@edit_pos, @@edit_font
	end

end

class SearchEntryModel < SearchTextModel

	def get_index
		:entry
	end

	def get_block(text)
		if text.length > 0
			lambda{|result, card|
				begin
					if Regexp.new(text) =~ card['参加作品']
						result << card
					end
				rescue
					# 正規表現エラーは無視
				end
				result
			}
		else
			nil
		end
	end

end

class SearchEntryView < SearchTextView

	@@text_label = '参加作品'.encode('CP932')
	@@text_pos = [20, 3, 110, 20]
	@@text_font = [FONT, 12, 0, 8]
	@@edit_pos = [135, 0, 125, 20]
	@@edit_font = [FONT, 12]

	def construct
		super @@text_label, @@text_pos, @@text_font, @@edit_pos, @@edit_font
	end

end

