# coding: utf-8

require 'observer'

class CardDetailModel

	include Observable

	def initialize(database)
		@database = database
	end

	def update(command, args)
		begin
			self.send command, *args
		rescue
			# 知らないコマンドは無視
		end
	end

	def selchanged(str)
		ret = @database.inject([]){|ans, card|
			if Regexp.new(card.to_s).match(str)
				ans << card
			else
				ans
			end
		}
		self.changed
		self.notify_observers :refresh, ret
	end

end
