# coding: utf-8

require 'observer'

class CardlistModel

	include Observable

	attr_reader :operator

	def initialize(database)
		@database = database
		@blocks = {}
	end

	def add_observer(observer)
		super observer
		self.changed
		self.notify_observers :refresh, [@database]
	end

	def update(command, args)
		self.send command, *args
	end

	def search(symbol, block)
		@blocks[symbol] = block
		list = @blocks.values.inject(@database) {|cardlist, block|
			if block
				cardlist.inject([]){|cardlist, card|
					block.call(cardlist, card)
				}
			else
				cardlist
			end
		}
		self.changed
		self.notify_observers :refresh, [list]
	end

end
