# coding: utf-8

require 'observer'

class DecklistModel

	include Observable

	class Deck < Hash

		def initialize
			@method = nil
			super
		end

		def change_strategy(method)
			@method = method
		end

		def sort_deck
			if @method
				@method.call(self)
			else
				sort
			end
		end

	end

	def initialize
		@deck = Deck.new
	end

	def add(str)
		if @deck[str]
			@deck[str] += 1
		else
			@deck[str] = 1
		end
		self.changed
		self.notify_observers :refresh, [@deck.sort_deck]
	end

	def del(str)
		if @deck[str]
			@deck[str] -= 1
			@deck.delete(str) if @deck[str] <= 0
			self.changed
			self.notify_observers :refresh, [@deck.sort_deck]
		end
	end

	def clear(*args)
		@deck = Deck.new
		self.changed
		self.notify_observers :refresh, [@deck.sort_deck]
	end

	def set_deck(deck)
		@deck = Deck.new
		deck.each{|array|
			@deck[array[0]] = array[1]
		}
		self.changed
		self.notify_observers :refresh, [@deck.sort_deck]
	end

	def get_deck
		@deck.sort_deck
	end

	def change_strategy(method)
		@deck.change_strategy method
		self.changed
		self.notify_observers :refresh, [@deck.sort_deck]
	end

	def update(command, args)
		begin
			self.send command, *args
		rescue
			# mȂR}h͖
		end
	end

end
