# coding: utf-8

require 'vr/vruby'
require 'observer'

require 'keycode'

class DelXCardView < VRButton

	include Observable
	include VRKeyFeasible
	include KeyCode

	def self_created
		super
		self.caption = @@del_x_card_view_text
		setFont @screen.factory.newfont *@@del_x_card_view_font
	end

	def clicked
		@@del_x_card_view_times.times{
			self.changed
			self.notify_observers :del, [nil]
		}
	end

	def self_char(key, code)
		case key
		when KeyCode::TAB
			step = if self.shift? then -1 else 1 end
			self.changed
			self.notify_observers :focus, [self, step]
		when KeyCode::CTRL_Y
			self.changed
			self.notify_observers :redo, [nil]
		when KeyCode::CTRL_Z
			self.changed
			self.notify_observers :undo, [nil]
		end
	end

end
