# coding: utf-8

require 'singleton'

module KeyCode

	TAB 	 = 9
	CTRL_Y = 25
	CTRL_Z = 26
	SPACE  = 32

	SHIFT  = 16

	def self_created
		addHandler WMsg::WM_KEYDOWN, 'keydown', MSGTYPE::ARGINTINT, nil
		addHandler WMsg::WM_KEYUP, 'keyup', MSGTYPE::ARGINTINT, nil
		acceptEvents [WMsg::WM_KEYDOWN, WMsg::WM_KEYUP]
	end

	def shift?
		ShiftKey.instance.shift
	end

	def self_keydown(k, d)
		ShiftKey.instance.shift = true if k == SHIFT
	end

	def self_keyup(k, d)
		ShiftKey.instance.shift = false if k == SHIFT
	end

	class ShiftKey

		include Singleton

		attr_accessor :shift

		def initialize
			@shift = false
		end

	end

end

