# coding: utf-8

require 'vr/vruby'
require 'vr/vrcontrol'
require 'vr/vrhandler'

require 'keycode'

class MyListbox < VRListbox

  include VRMouseFeasible
  include VRMessageHandler
  include KeyCode

  def vrinit
    super
    addHandler WMsg::WM_LBUTTONDBLCLK, 'ldblclicked', MSGTYPE::ARGINTSINTSINT, nil
    addHandler WMsg::WM_RBUTTONDBLCLK, 'rdblclicked', MSGTYPE::ARGINTSINTSINT, nil
    addHandler WMsg::WM_CHAR, 'char', MSGTYPE::ARGINTINT, nil
    acceptEvents [WMsg::WM_LBUTTONDBLCLK, WMsg::WM_RBUTTONDBLCLK, WMsg::WM_CHAR]
  end

  def self_ldblclicked(*args)
    @parent.send "#{@name}_ldblclicked", *args
  end

  def self_rdblclicked(*args)
    @parent.send "#{@name}_rdblclicked", *args
  end

  def self_lbuttondown(*args)
    @parent.send "#{@name}_lbuttondown", *args
  end

  def self_lbuttonup(*args)
    @parent.send "#{@name}_lbuttonup", *args
  end

  def self_rbuttondown(status, x, y)
    sendMessage WMsg::WM_LBUTTONDOWN, status - 1, y << 16 | x
  end

  def self_rbuttonup(status, x, y)
    sendMessage WMsg::WM_LBUTTONUP, status, y << 16 | x
  end

  def self_char(*args)
    @parent.send "#{@name}_char", *args
  end

end
