# coding: utf-8

require 'vr/vruby'
require 'vr/vrcontrol'
require 'observer'

require 'my_checkbox'
require 'keycode'

class SearchCheckboxView < VRPanel

	include Observable
	include VRStdControlContainer
	include KeyCode

	FONT = 'ＭＳ ゴシック'.encode('Windows-31J')

	def construct(text_label, text_pos, text_font)
		addControl MyCheckbox, 'checkbox', text_label, *text_pos
		@checkbox.setFont @screen.factory.newfont *text_font
	end

	def checkbox_set(val, update = false)
		@checkbox.check val
		checkbox_clicked if update
	end

	def checkbox_clicked
		self.changed
		self.notify_observers :search, [self, @checkbox.checked?]
	end

	def checkbox_char(key, code)
		case key
		when KeyCode::TAB
			step = if self.shift? then -1 else 1 end
			self.changed
			self.notify_observers :focus, [@checkbox, step]
		end
	end

end
