# coding: utf-8

require 'vr/vruby'
require 'vr/vrcontrol'
require 'observer'

require 'my_edit_combobox'
require 'keycode'

class SearchComboView < VRPanel

	include Observable
	include VRStdControlContainer
	include KeyCode

	FONT = 'ＭＳ ゴシック'.encode('Windows-31J')

	attr_reader :edit

	def construct(text_label, text_pos, text_font, edit_pos, edit_font)
		addControl VRStatic, 'text', text_label, *text_pos
		addControl MyEditCombobox, 'edit', '', *edit_pos
		@text.setFont @screen.factory.newfont *text_font
		@edit.setFont @screen.factory.newfont *edit_font
	end

	def edit_text=(str)
		@edit.text = str
	end

	def set_list(list)
		array = [""] + list
		array.each{|i|
			@edit.addString i.encode('Windows-31J')
		}
		@prev = 0
		@edit.select 0
	end

	def edit_selchanged
		current = @edit.selectedString
		if @prev != current
			@prev = current
			self.changed
			self.notify_observers :search, [@edit.getTextOf(current).encode('UTF-8')]
		end
	end

	def edit_changed
		text = @edit.text
		text = "" if /^\s*$/ =~ text
		if @text != text
			@text = text
			self.changed
			self.notify_observers :search, [@text.encode('UTF-8')]
		end
	end

	def edit_char(key, code)
		case key
		when KeyCode::TAB
			step = if self.shift? then -1 else 1 end
			self.changed
			self.notify_observers :focus, [@edit, step]
		end
	end

end
